#---
# Excerpted from "Functional Programming: A PragPub Anthology",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material,
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose.
# Visit http://www.pragmaticprogrammer.com/titles/ppanth for more book information.
#---
defmodule Fibonacci do

  def fib(0), do: 1
  def fib(1), do: 1
  def fib(n) when is_integer(n) and  n > 1, do: fib(n-2)+fib(n-1)
  def fib(x), do: raise "Can't find fib(#{x})"

end

Fibonacci.fib(10)     #=> 89
Fibonacci.fib(-10)    #=> ** (RuntimeError) Can't find fib(-10)
Fibonacci.fib("cat")  #=> ** (RuntimeError) Can't find fib(cat)
