#---
# Excerpted from "Functional Programming: A PragPub Anthology",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material,
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose.
# Visit http://www.pragmaticprogrammer.com/titles/ppanth for more book information.
#---
cheery = fn ->
  IO.puts "In spawned process #{inspect self()}"
  receive do
    msg -> IO.puts "Well, hello #{msg}"
  end
end

pid = cheery |> spawn

IO.puts "Spawned process #{inspect pid}"

send pid, "world!"

IO.puts "Message sent"
