#---
# Excerpted from "Functional Programming: A PragPub Anthology",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material,
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose.
# Visit http://www.pragmaticprogrammer.com/titles/ppanth for more book information.
#---
cheery = fn ->
  receive do
    { from_pid, :en, msg } ->                  
        send from_pid, "Well, hello #{msg}"
    { from_pid, :fr, msg } ->                  
        send from_pid, "Bonjour #{msg}"
    { from_pid, :es, msg } ->                  
        send from_pid, "Hola #{msg}"
  end
end

pid = cheery |> spawn

send pid, { self(), :es, "mundo!" }                 
receive do
  msg -> IO.puts "The process said: #{inspect msg}" 
end

send pid, { self(), :fr, "world!" }                 
receive do
  msg -> IO.puts "The process said: #{inspect msg}" 
end
